# include "../precc.new/ccx.h"
# include "cobol.lex.h"


	/* ------------ DATA DIVISION ------------------------ */

@data_division    =  <C_DATA> <C_DIVISION> stop
@	       		       [ file_section ]
@                      [ working_storage_section ]
@                      [ linkage_section ]
@                      [ report_section ]

@file_section     =  <C_FILE> <C_SECTION> stop
@						 file_descriptions

@file_descriptions=   file_description*

typedef struct {
	char *name;
	char *alias;
	} RECORD_D;

typedef struct {
	char *name;
	char *nblk;
	char *nrec;
	char *lbls;
	RECORD_D record;
	} FILE_D;
FILE_D file_d;

@file_description = <C_FD> identifier(&file_d.name)
@	      			[ block_data(&file_d.nblk) ]
@	      			[ record_data(&file_d.nrec)]
@                   label_data(&file_d.lbls)
@	     			stop       			
@	       			record_description(1)

static char *num;

@block_data(b)    = <C_BLOCK> <C_CONTAINS>
@	      			natnum_rep(b) <C_RECORDS>

@record_data(b)   = <C_RECORD> <C_CONTAINS>
@	      			natnum_rep(b) <C_CHARACTERS>

@label_data(b)    = <C_LABEL> <C_RECORDS>
@	      			identifier(b)

	/* records of level AT LEAST L */

@record_descriptions(L)=
@	      record_description(L)*

@record_description(L)= record_d(L)
@		         | level_88_d
@		         | )L<9( record_description(L+1)
	
	/* record of level EXACTLY Level */

static RECORD_D rec_d;

@record_d(Level)  = level_number(Level)
@                   identifier(&rec_d.name)
@                   [ redefines_part(&rec_d.alias) ]
@                    stop
@                   data_descriptions(Level+1)

@redefines_part(b)= <C_REDEFINES> identifier(b)

	/* fields of level AT LEAST LEVEL */

@data_descriptions(LEVEL) =
@                   data_description(LEVEL)*

@data_description(L)= data_des(L)                      
@	              |  )L<9( data_description(L+1)
		
@data_des(L)      =  data_d(L)                         
@	     	      |	value_d(L)                        
@	     	      |	)L<9( record_d(L)


		/* single field record */

@level_88         =   <'8'> <'8'> | <'7'> <'7'>

typedef char *FORMATS[10];
static FORMATS format;

static char *datatag;

@level_88_d       =   level_88
@                     identifier(&rec_d.name)
@	                  level_88_d_c

@level_88_d_c     =   [ redefines_part(&rec_d.alias)  ]
@                     [ <C_PIC> format_descrip(format) ]
@                     [ level_88_tags ]
@                    stop

@level_88_tags    =   level_88_tag { literal_iden level_88_tag }*

@level_88_tag     = <C_VALUE> [<C_IS>] ranges_cob_exp(&datatag)

	/* field of level EXACTLY L */

typedef struct {
	char *name;
	char *alias;
	char *mult;
	char *key;
	char *index;
	} FIELD_D;
static FIELD_D field_d;

@data_d(L)        =  level_number(L)
@                    identifier(&field_d.name)
@                    [ redefines_part(&field_d.alias) ]
@                    <C_PIC> format_descrip(format)
@                    [ occurrences_part(&field_d.mult,&field_d.key,&field_d.index) ]
@                    [ level_88_tags ]
@                    stop

	/* value of level EXACTLY L */
		
static char *valuename;
typedef struct {
	char *value;
	char *name;
	char *alias;
	char *usage;
	char *mult;
	char *key ;
	char *index;
	} VALUE_D;
static VALUE_D val_d;


@value_d(L)      =   value_descrip(&val_d.value)
@	     			 level_number(L)
@                    identifier(&val_d.name)
@	      			 value_d_c(L)

@value_d_c(L)   =    [ redefines_part(&val_d.alias) ]
@	     			 [ format_part(format) ]
@                    [ usage_part(&val_d.usage) ]
@                    [ occurrences_part(&val_d.mult,&val_d.key,&val_d.index) ]
@                    stop

@format_part(f) =   <C_PIC> format_descrip(f)

@ranges_cob_exp(b)=  <C_ALL> cob_exp                
@               |    cob_exp [ <C_THRU> cob_exp ]

@format_descrip(b)= single_format(&FORMAT(b))
@           	    [ format_descrip(&NXTFMT(b)) ]

@single_format(b) = x_string(b)                        
@                 | nine_string(b)                     
@                 | z_string(b)

	/* ETC */

@value_descrip(v) = <C_VALUE> cob_exp

@usage_part(b)    =  <C_USAGE> [<C_IS>] identifier(b)

@occurrences_part(b,c,d)=
@	     			 <C_OCCURS> ranges_part(b)
@                     [ key_part(c) ]
@                     [ indexing_part(d) ]

@ranges_part(b)   = natnum_rep(b) [ <C_TIMES> ]

@key_part(c)      = {<C_ASCENDING> | <C_DESCENDING> }
@                    <C_KEY> [<C_IS>] identifier(c)

@indexing_part(d) =  <C_INDEXED> <C_BY> identifier(d)

@working_storage_section =
@                    <C_WORKING_STORAGE> <C_SECTION>
@                    stop
@                    w_s_s

@w_s_s            =   record_descriptions(1)

@linkage_section  = <C_LINKAGE> <C_SECTION>
@                    stop
@                    w_s_s

@report_section   =  <C_REPORT> <C_SECTION>
@                    stop
@                    report_files

@report_files     = report_file*

static char *reportname;

@report_file      =  <C_RD> identifier(&reportname)
@                    stop
@                    report_records

@report_records   = report_record*

static char *reportrecordname;

@report_record    = level_number(1)
@	     			identifier(&reportrecordname)
@                   report_sources
@                   stop

static char *reportsourcename;

@report_sources   = {<C_SOURCE> identifier(&reportsourcename) }*

