/** fib.y test file for PRECCX v2.42       P.T. Breuer August 1994 **/

# define TOKEN char

# define VALUE char*

# include "ccx.h"

# include <math.h>

# include <alloc.h>

# define INT(x) (int)(x)

# define DIV(m,n) INT(INT(m)/INT(n))

# define MOD(m,n) INT(INT(m)%INT(n))

# define LOG10(n) INT(log10((double)(n)))

# define DBLE(n)  (double)(n)

# define TEN      DBLE(10)

# define FIRSTDIGIT(n)            \
          (0!=n)?DIV((n),pow(TEN,DBLE(LOG10(n)))):0

# define LASTDIGITS(n)            \
          (0!=n)?MOD((n),pow(TEN,DBLE(LOG10(n)))):0

MAIN(fibber)

static STATUS hid0(){
PARSER fibs, p_lastuniq0;
return p_andparse0n (TOPARSER fibs,0,TOPARSER p_lastuniq0,0);
}
static STATUS hid1(){
PARSER hid0;
return p_many0n(TOPARSER hid0,0);
}
STATUS fibber(){
PARSER hid1;
return((TOPARSER hid1)());
}

static VOID hid2(PARAM k){
 printf("%d terms OK\n",(TOVALUE k)); 
}
static STATUS hid3(PARAM k){
PARSER p_nothing0;ACTION hid2;
return p_attach0n(TOPARSER p_nothing0,0,hid2,1,k);
}
static STATUS hid4(){
PARSER fib, hid3; PARAM k;
static STATUS p_tok;
P_PSTAR(k,(TOPARSER fib)((PARAM)1,(PARAM)1),(TOPARSER hid3)(k));
return p_tok;
}
STATUS fibs(){
PARSER hid4;
return((TOPARSER hid4)());
}

static STATUS hid5(PARAM a,PARAM b){
return p_exactly0(',');
}
static STATUS hid6(PARAM a,PARAM b,PARAM k){
return p_atch0((PARAM)((TOVALUE k)+1));
}
static STATUS hid7(PARAM a,PARAM b){
PARSER fib, hid6; PARAM k;
static STATUS p_tok;
P_PSTAR(k,(TOPARSER fib)(b,a+b),(TOPARSER hid6)(a,b,k));
return p_tok;
}
static STATUS hid8(PARAM a,PARAM b){
PARSER hid5, hid7;
return p_andparse0n (TOPARSER hid5,2,a,b,TOPARSER hid7,2,a,b);
}
static STATUS hid9(PARAM a,PARAM b){
PARSER number, hid8;
return p_andparse0n (TOPARSER number,1,a,TOPARSER hid8,2,a,b);
}
static STATUS hid10(PARAM a,PARAM b){
return p_exactly0('.');
}
static STATUS hid11(PARAM a,PARAM b){
return p_exactly0('.');
}
static STATUS hid12(PARAM a,PARAM b){
return p_atch0((PARAM)(0));
}
static VOID hid13(PARAM a,PARAM b){
 printf("Next terms are %d,%d,..\n",(int)a,(int)b);
}
static STATUS hid14(PARAM a,PARAM b){
PARSER p_nothing0;ACTION hid13;
return p_attach0n(TOPARSER p_nothing0,0,hid13,2,a,b);
}
static STATUS hid15(PARAM a,PARAM b){
PARSER hid12, hid14;
return p_andparse0n (TOPARSER hid12,2,a,b,TOPARSER hid14,2,a,b);
}
static STATUS hid16(PARAM a,PARAM b){
PARSER hid11, hid15;
return p_andparse0n (TOPARSER hid11,2,a,b,TOPARSER hid15,2,a,b);
}
static STATUS hid17(PARAM a,PARAM b){
PARSER hid10, hid16;
return p_andparse0n (TOPARSER hid10,2,a,b,TOPARSER hid16,2,a,b);
}
static STATUS hid18 (PARAM a,PARAM b){
PARSER hid9, hid17;
static STATUS p_tok;
p_tok = (TOPARSER hid9) (a,b);
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid17) (a,b);
}
STATUS fib(PARAM a,PARAM b){
PARSER hid18;
return((TOPARSER hid18)(a,b));
}

static STATUS hid19(PARAM n){
PARSER digit, number;
return p_andparse0n (TOPARSER digit,1,FIRSTDIGIT(n),TOPARSER number,1,LASTDIGITS(n));
}
static STATUS hid20 (PARAM n){
PARSER digit, hid19;
static STATUS p_tok;
p_tok = (TOPARSER digit) (n);
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid19) (n);
}
STATUS number(PARAM n){
PARSER hid20;
return((TOPARSER hid20)(n));
}

static STATUS hid21(PARAM n){
return p_exactly0(n+'0');
}
STATUS digit(PARAM n){
PARSER hid21;
return((TOPARSER hid21)(n));
}

/************************************************************
     The following are some example inputs and responses:

          1,1,2,3,5,..
          Next terms are 8,13,..
          5 terms OK

          1,1,2,3,5,8,13,21,34,51,85,..
          error: failed parse: probable error at <>1,85,..
 ************************************************************/



